import sys
import numpy as np

n = len( sys.argv )
if n != 3 :
	print( "Args: x0 y0" )
	sys.exit(1)

v = np.array( [[float( sys.argv[1] )], [float( sys.argv[2] )] ] )

def evaluateJ( J, x, y) :
	a = y - x*x
	J[0,0] = -2 + 2*x - 400*x*a
	J[1,0] = 200*a

def evaluateH( H, x, y ) :
	H[0,0] = 2 + 800*x*x - 400*(y-x*x)
	H[0,1] = -400*x
	H[1,0] = -400*x
	H[1,1] = 200

def inverse( A, Ainv ) :
	detA = A[0,0]*A[1,1] - A[1,0]*A[0,1]
	Ainv[0,0] = A[1,1]
	Ainv[0,1] = -A[0,1]
	Ainv[1,0] = -A[1,0]
	Ainv[1,1] = A[0,0]

	Ainv = Ainv/detA 
	return Ainv


J = np.zeros( (2,1) )
H = np.zeros( (2,2) )
Hinv = np.zeros( (2,2) )
	

i = 1
while i <= 20 :
	evaluateJ( J, v[0,0], v[1,0] )
	evaluateH( H, v[0,0], v[1,0] )
	Hinv = inverse( H, Hinv )

	delta_v = Hinv @ J
	v = v - delta_v
	print( i, v[0,0], v[1,0] )

	n = delta_v[0,0]*delta_v[0,0] + delta_v[1,0]*delta_v[1,0]
	if np.sqrt(n) < 1e-8 :
		break

	i += 1
